



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++11 常用语法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++11 常用语法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 07:48:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>1 新类型</h1>
<p>C++ 11新增了long long和unsigned long long，以支持64bit宽度；</p>
<p>新增char16_t和char32_t以支持16位和32位字符表示；</p>
<p>增加了&ldquo;原始&rdquo;字符串。</p>
<h1>2 初始化</h1>
<p>C++ 11扩展了大括号{}的适用范围，既可以用于基本类型，也可以用于自定义类型：</p>
<p>int x = {5};</p>
<p>couble y{3.5};</p>
<p>short quar[5]{1, 2, 3, 4, 5};</p>
<p>int* p = new int[5]{1, 2, 3, 4, 5};</p>
<p>创建对象时，也可以使用大括号链表来调用构造函数：</p>
<p>class Stump</p>
<p>{</p>
<p>Public:</p>
<p>Stump(int r, double w) : roots(r), weight(w){}</p>
<p>Private:</p>
<p>int roots;</p>
<p>double weight;</p>
<p>};</p>
<p>Stump s1(3, 4.5); // old style</p>
<p>Stump s2{3, 4.5}; // new style</p>
<p>Stump s3 = {3, 4.5};&nbsp;&nbsp;&nbsp;&nbsp; // new style</p>
<p>注意：使用初始化列表可以防止向下转型，如：</p>
<p>char c1 = 1.57e27;&nbsp;&nbsp; // double-to-char, undefined behavior</p>
<p>char c1{1.57e27}; // double-to-char, compile error</p>
<p>std::initializer_list可以作为函数参数，如果一个类中的构造函数使用了这种方法，则其他函数将不能再使用其作为参数，这是为了防止调用二义性。</p>
<p>Initializer_list模板类提供了两个成员函数begin()和end()，用来指定列表的范围，如：</p>
<p>double sum(std::initializer_list&lt;double&gt; il)</p>
<p>{</p>
<p>double total = 0;</p>
<p>for(auto p = il.begin(); p != il.end(); p++)</p>
<p>total += *p;</p>
<p>return total;</p>
<p>}</p>
<p><strong>double total = sum({1, 2.5, 8.3, 2.2, 1.0});</strong></p>
<h1>3 声明</h1>
<p>C++提供了多种简化声明的方式，尤其在使用模板时更加方便。</p>
<p><strong>1 auto</strong>：用来实现自动类型推断，如：</p>
<p>auto i = 112;&nbsp;&nbsp;&nbsp;&nbsp; // i is type int</p>
<p>auto pt = &amp;i;&nbsp;&nbsp;&nbsp;&nbsp; // pt is type int*</p>
<p>double fm(double, int);</p>
<p>auto pf = fm;&nbsp;&nbsp;&nbsp;&nbsp; // pf if type double(*)(double, int);</p>
<p>用于模板时形式简洁，如：</p>
<p>for(std::initializer_list&lt;double&gt;::iterator p = il.begin();&nbsp;p != il.end(); p++)</p>
<p>改写为：</p>
<p>for(auto p = il.begin(); p != il.end(); p++)</p>
<p><strong>2 decltype</strong><strong>：</strong>将变量的类型指定为表达式的类型。</p>
<p>decltyte (x) y; 将y设为与x相同的类型，其中x是一个表达式。</p>
<p><strong>3 </strong><strong>返回类型后置：</strong>在函数名和参数列表后面指定返回类型。</p>
<p>double f1(double int); 　　　　　　　// return double type</p>
<p>auto f2(double, int) -&gt; double; 　　// new syntax, return double type</p>
<p>如果结合上模板表示返回类型，那就更好了，如下：</p>
<p>template&lt;typename T, typename U&gt;</p>
<p>auto eff(T t, U u) -&gt; decltype(T * U)</p>
<p>{</p>
<p>}</p>
<p><strong>4 </strong><strong>模板别名：using =</strong></p>
<p>C++中创建别名一般用typedef，如：</p>
<p>typedef std::vector&lt;std::string&gt;::iterator itType;</p>
<p>还可以这样做：</p>
<p>using itType = std::vector&lt;std::string&gt;::iterator;</p>
<p>二者的差别在于，using可以使模板具体化，如：</p>
<p>using arr = std::array&lt;T, <strong>12</strong>&gt;;，此时typedef不行。</p>
<p><strong>5 nullptr</strong><strong>：</strong>空指针</p>
<p>之前，C++使用0表示空指针，同样的0既可以表示整型，又可以表示空指针，比较混乱；新增的nullptr是指针类型，不能转换为整型。为了兼容性，C++目前仍然允许0表示空指针，即nullptr == 0的结果为true。</p>
<h1>4 智能指针</h1>
<p>C++ 11摒弃了auto_ptr，新增了三种：unique_ptr、shared_ptr、weak_ptr。</p>
<h1>5 异常</h1>
<p>之前C++的语法中可以指出函数可能引发哪些异常，如：</p>
<p>void f1(int) throw(bad_alloc);&nbsp; // 可能抛出bad_alloc异常</p>
<p>void f2(long long) throw();&nbsp;&nbsp;&nbsp;&nbsp; // 不抛异常</p>
<p><strong>C++</strong><strong>摒弃了异常规范，新增了如下规则：</strong></p>
<p><strong>Void f3(short, short) noexcept; // </strong><strong>不抛异常</strong></p>
<h1>6 作用域内枚举</h1>
<p>传统的C++枚举的作用域在所属的域内，就是说同一作用域内不能出现两个同名的枚举变量。</p>
<p>C++ 11新增了一种枚举，使用class或者struct定义：</p>
<p>enum Old{yes, no};&nbsp;&nbsp; // old style</p>
<p>enum class New{yes, no}; // new style</p>
<p>enum struct New{yes, no};&nbsp;&nbsp; // new style</p>
<p>由于允许同名存在，因此引用时需要使用枚举名限定：New::yes。</p>
<h1>7 对类的修改</h1>
<p>在扩展类的设计方面，C++ 11很多改进，比如允许构造函数被继承、彼此调用、移动构造函数、移动赋值运算符等。</p>
<p><strong>7.1 显示转换运算符</strong></p>
<p>早期的C++会导致自动类型转换，比如：</p>
<p>class Plebe</p>
<p>{</p>
<p>Plebe(int);</p>
<p>explicit Plebe(double);</p>
<p>...</p>
<p>};</p>
<p>Plebe a, b;</p>
<p><strong>a = 5;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; // </strong><strong>发生隐式类型转换，实则调用Plebe(5);</strong></p>
<p><strong>b = 0.5;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; // </strong><strong>不允许</strong></p>
<p>b = Plebe(0.5);&nbsp;&nbsp; // 允许</p>
<p>C++ 11扩展了explicit，使得可以如下这样做：主要是针对转换函数：</p>
<p>比如：</p>
<p>operator int() const;</p>
<p>explicit operator double() const;</p>
<p>int n = a;&nbsp;&nbsp;&nbsp; // allow</p>
<p>double x = b;&nbsp;&nbsp;&nbsp;&nbsp; // not allow</p>
<p>x = double(b);&nbsp;&nbsp;&nbsp; // allow</p>
<p><strong>7.2 类内成员初始化</strong></p>
<p>class Session</p>
<p>{</p>
<p>int mem = 10;</p>
<p>double mem2{2.35};</p>
<p>...</p>
<p>};</p>
<h1>8 模板和STL方面</h1>
<p>为了改善模板和标准化方面的易用性，C++ 11做了多个改进：</p>
<p><strong>8.1 改进的for循环</strong></p>
<p>double prices[5] = {1, 2, 3, 4, 5};</p>
<p>for(double x : prices)</p>
<p>for(auto x : prices)</p>
<p>如果要在循环中修改数组或容器中的每个元素，可以使用引用：</p>
<p>for(auto&amp; x : prices)</p>
<p><strong>8.2 新增的STL容器</strong></p>
<p>C++ 11新增了forward_list、unordered_map、unordered_multimap、unordered_set、unordered_multiset。</p>
<p>新增了模板array，实例化时指定元素类型和个数：std::array&lt;int, 10&gt; ar; // 10个int</p>
<p><strong>8.3 新增STL方法</strong></p>
<p>cbegin()、cend()、crbegin()、crend()。这几个方法将容器元素视为const。</p>
<p><strong>8.4 valarray升级版</strong></p>
<p>对于valarray模板，C++ 11新增了两个方法begin()和end()。</p>
<p><strong>8.5 摒弃了export</strong></p>
<p>C++ 98增加的关键字export可以让程序员将模板定义放在接口文件中，实现文件中放置方法体，但是实践证明这一点也不现实，因此C++ 11把它摒弃了。</p>
<p><strong>8.6 尖括号</strong></p>
<p>旧时的C++要求在定义嵌套的模板时，两个尖括号之间必须有空格，比如：vector&lt;list&lt;int&gt; &gt;，但是C++ 11中不再需要这样了，比如vector&lt;list&lt;int&gt;&gt;也可以通过的。</p>
<h1>9 右值引用</h1>
<p>C++新增了右值引用，使用&amp;&amp;表示。【相对于左值，右值表示字面常量、表达式、函数的非引用返回值等】</p>
<p>如：</p>
<p>int&amp;&amp; r1 = 12;</p>
<p>int x = 5;</p>
<p>int y = 8;</p>
<p>int&amp;&amp; r2 = x + y;</p>
<p>我们可以通过r1来修改12，很方便。</p>
<h1>10 移动语义和右值引用</h1>
<p><strong>10.1 </strong><strong>为何需要移动语义</strong></p>
<p>移动语义就是为了避免多余的复制工作，就是说与其复制，还不如将源地址传给使用者，因为有时复制工作确是没什么用。</p>
<p>要实现移动语义，需要采用某种措施让编译器知道到底什么情况下需要复制，什么情况下不必复制。这时，右值引用就可以配上用场了。</p>
<p>传统的复制构造函数执行深复制，并且不改变实参，因此，参数为const类型；</p>
<p>移动构造函数只是更改了引用记录，并且可能会改变实参，因此，参数必须是非const类型；</p>
<p>如下实例：</p>
<p>class Use</p>
<p>{</p>
<p>public:</p>
<p>Use();</p>
<p>Use(const Use&amp; f);&nbsp;&nbsp; // copy constructor</p>
<p>Use(Use&amp;&amp; f);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; // move constructor</p>
<p>...</p>
<p>private:</p>
<p>int n;</p>
<p>char* pc;</p>
<p>};</p>
<p>...</p>
<p>Use::Use(const Use&amp; f) : n(f.n) // 深复制</p>
<p>{</p>
<p>pc = new char[n];</p>
<p>for(int i = 0; i &lt; n; i++)</p>
<p>pc[i] = f.pc[i];</p>
<p>}</p>
<p>Use::Use(Use&amp;&amp; f) : n(f.n)</p>
<p>{</p>
<p>pc = f.pc;&nbsp;&nbsp;&nbsp; // 移动构造，转移控制权</p>
<p>f.pc = nullptr;</p>
<p>f.n = 0;</p>
<p>}</p>
<p><strong>10.2 </strong><strong>移动构造解析</strong></p>
<p>虽然移动构造定义好了，但是如何调用呢，也就是说什么情况下才会发生移动构造呢？</p>
<p>必须<strong>使用右值引用调用</strong>：</p>
<p>Use two = one;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; // match Use::Use(const Use&amp;);</p>
<p>Use four(one + three);&nbsp; // match Use::Use(Use&amp;&amp;);</p>
<p>因为one是左值，而one + three是右值。</p>
<p>移动赋值情况类似，不记录了。</p>
<p><strong>10.3 </strong><strong>强制移动</strong></p>
<p>移动构造和移动赋值使用右值引用，如果需要让他们操作左值呢？</p>
<p>答案是使用static_cast&lt;&gt;将对象强制转换为Use&amp;&amp;即可。不过在C++ 11种提供了更便捷的操作，在头文件utility中声明的函数std::move(...)。</p>
<p>如果使用了std::move()函数调用，但是类中却没有定义移动相关函数，那么编译器会调用传统版本的移动构造函数和移动赋值操作符。</p>
<h1>11 新的类功能</h1>
<p>假设你为类定义了构造函数,那么类就不会自动提供默认的构造函数了,然而,如果你仍然想使用类提供的默认版本,那么可以使用default关键字：</p>
<p>class Some</p>
<p>{</p>
<p>public:</p>
<p>Some(Some&amp;&amp;);</p>
<p><strong>Some() = default; // use default constructor</strong></p>
<p>...</p>
<p>};</p>
<p>相反地，如果要禁用编译器提供的默认函数，可以使用delete:</p>
<p>class Some</p>
<p>{</p>
<p>public:</p>
<p>Some(Some&amp;&amp;);</p>
<p>Some() = default; // use default constructor</p>
<p><strong>Some(const Some&amp;) = delete; //disable copy constructor</strong></p>
<p>...</p>
<p>};</p>
<p>当然要想禁用某个编译器提供的函数也可以显式声明为private，但是使用delete更方便且不易出错。</p>
<p>注意：default关键字只能用于6个特殊函数，而delete却能够用于任何成员函数。</p>
<p><strong>委托构造</strong></p>
<p>如果一个类包含多个构造函数，C++ 11允许在一个构造函数中的定义中使用另一个构造函数，但这必须通过初始化列表进行操作，如下：</p>
<p>class Notes</p>
<p>{</p>
<p>int k; double x; string s;</p>
<p>public:</p>
<p>Notes(int kk, double xx, string ss) : k(kk), x(xx), s(ss){ }</p>
<p>Notes(int kk) : Notes(0, 0.5, &ldquo;benxin&rdquo;){ k = kk; }</p>
<p>...</p>
<p>};</p>
<p><strong>继承构造</strong></p>
<p>C++ 11允许派生类继承基类的构造函数。C++ 98提供了一种让某个名称空间中的同名重载函数都可用的语法，如下：</p>
<p>namespace Box</p>
<p>{</p>
<p>int fn(){}</p>
<p>int fn(int){}</p>
<p>int fn(double){}</p>
<p>}</p>
<p>using Box::fn;该语句使得fn的所有重载版本都可用。我们一般使用这种方法在派生类中调用基类的同名函数。之所以提供这种语法，就是因为覆盖是以函数名为基础的，不论参数是否对应都将被覆盖。</p>
<p>C++ 11将这种语法用于构造函数中，使得派生类将继承基类的构造函数（默认构造函数、复制构造函数、移动构造函数除外）。</p>
<p><strong>管理虚方法：override</strong><strong>和final</strong></p>
<p>传统的虚函数是为了实现多态调用，但这必须是派生类与基类的虚函数签名完全一致的情况下才会发生多态，如果不一致，假设如下：</p>
<div>
<pre class="prettyprint linenums"> class Base<br />
 {<br />
 public:<br />
     virtual void <strong>Fn()</strong>{ cout &lt;&lt; "Base::Fn()" &lt;&lt; endl; }<br />
 };

 class Derived : public Base<br />
 {<br />
 public:<br />
     virtual void <strong>Fn(int)</strong>{ cout &lt;&lt; "Derived::Fn()" &lt;&lt; endl; }<br />
 };

 int main()<br />
 {<br />
     <strong>Base* d = new Derived;<br />
16     d-&gt;Fn();<br />
</strong><br />
     return ;<br />
 }</pre>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/759985/201507/011348195624919.png" /></p>
<pre class="prettyprint linenums"></pre>
</div>
<p>结果如上，编译器竟然会根据指针的静态类型发生了调用，并无多态发生。</p>
<p>好在C++ 11提供了override指出了该虚函数是为了覆盖基类的虚函数而存在的，此时如果不小心与基类中的虚函数不一致了，那么编译器不会让你通过的。</p>
<div>
<pre class="prettyprint linenums"> class Derived : public Base<br />
 {<br />
 public:<br />
     virtual void Fn(int) <strong>override</strong>{ cout &lt;&lt; "Derived::Fn()" &lt;&lt; endl; }<br />
 };</pre>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/759985/201507/011350545153948.png" /></div>
<p>如果想禁止派生类覆盖基类的虚函数，可在基类的虚函数参数列表后加上final。</p>
<div>
<pre class="prettyprint linenums"> class Base<br />
 {<br />
 public:<br />
     virtual void Fn() <strong>final</strong>{ cout &lt;&lt; "Base::Fn()" &lt;&lt; endl; }<br />
 };

 class Derived : public Base<br />
 {<br />
 public:<br />
     virtual void Fn() <strong>override</strong>{ cout &lt;&lt; "Derived::Fn()" &lt;&lt; endl; }<br />
 };</pre>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/759985/201507/011351382654915.png" /></p>
<pre class="prettyprint linenums"></pre>
</div>
<p>最后需要指出的是：override和final并非关键字，而是具有特殊含义的标识符，编译器会根据上下文确定其到底是否代表特殊性。</p>
<h1>12 Lambda函数</h1>
<p>如下示例使用了三种方法给STL算法传递信息：<strong>函数指针、函数符、</strong><strong>lambda</strong><strong>函数</strong>。出于方便性，我们将其统称为函数对象。</p>
<p>假设生成一个包含1000个数的容器，并判断其中有多少个可以被3整除，有多少个可以被13整除：</p>
<p>vector&lt;int&gt; numbers(1000);</p>
<p>generate(numbers.begin(), numbers.end(), <strong>rand</strong>);</p>
<p>说明：generate函数前两个参数指定容器区间，并将每个元素设置为第三个参数返回的值。</p>
<p>bool f3(int x){ return x % 3 == 0; }</p>
<p>bool f13(int x){ return x % 13 == 0; }</p>
<p>接下来可以借助于count_if函数，该函数前两个参数也是指定区间，第三个参数是一个返回true或false的函数对象，该函数计算使得返回true的元素个数。</p>
<p>int count = count_if(numbers.begin(), numbers.end(), <strong>f3</strong>);</p>
<p>如上述所示，rand和f3都是作为<strong>函数指针</strong>传递过去的。</p>
<p>下面看一下<strong>函数符</strong>如何使用：</p>
<p>我们知道函数符是一个类对象，主要利用重载()操作符来完成任务：</p>
<p>class f_mod</p>
<p>{</p>
<p>public:</p>
<p>f_mod(int d = 1) : dv(d){ }</p>
<p>bool operator()(int x){ return x % dv == 0; }</p>
<p>private:</p>
<p>int dv;</p>
<p>};</p>
<p>创建对象：</p>
<p>f_mod obj(3);&nbsp;&nbsp;&nbsp;&nbsp; 　　// set dv to 3</p>
<p>使用：</p>
<p>bool rv = obj(7); 　　// <strong>same as obj.operator()(7); </strong></p>
<p>　　　　// return 7 % 3 == 0</p>
<p>因此：</p>
<p>int count = count_if(numbers.begin(), numbers.end(), <strong>f_mod(3))</strong>;</p>
<p>最后看看如何使用<strong>lambda</strong>：C++ 11中，对于接受函数指针或函数符的函数，也可以使用<strong>匿名函数定义</strong><strong>(lambda)</strong>作为其参数：</p>
<p>bool f3(int x){ return x % 3 == 0; }</p>
<p>上述函数f3用lambda来表示即为：</p>
<p>[](int x){ return x % 3 == 0; }</p>
<p><strong>lambda</strong><strong>和一般函数的区别如下：</strong></p>
<p>使用[]代替函数名；没有返回类型。返回类型相当于使用decltype推断而得。如果表达式中不包括返回语句，则推断出类型为void。<strong>但要特别注意，仅当</strong><strong>lambda</strong><strong>表达式中仅包含一条返回语句时，自动推断类型才起作用；否则，需要使用新增的返回类型后置语法，</strong>如下：</p>
<p>[](double x)<strong> -&gt; double </strong>{ int y = x; return x &ndash; y; }</p>
<p>int count = count_if(numbers.begin(), numbers.end(), [](int x){ return x % 3 == 0; });</p>
<p><strong>我们也可以给lambda</strong><strong>指定一个名称，如：</strong></p>
<p><strong>auto mod3 = [](int x){ return x % 3 == 0; }</strong></p>
<p>int count = count_if(numbers.begin(), numbers.end(), <strong>mod3</strong>);</p>
<p>当然，我们也可以像普通函数一样使用lambda，如：mod3(z); ---&gt; return z % 3 == 0;</p>
<p>还有，<strong>lambda</strong><strong>还可以操作变量</strong>，如：</p>
<p>[count]：表示以传值方式访问变量；</p>
<p>[&amp;count]：表示以引用方式访问变量；</p>
<p>[count1, &amp;count2]：以传值方式访问count1，以引用方式访问count2;</p>
<p>[&amp;, count]：表示以传值方式访问count，以引用方式访问其他变量；</p>
<p>[=]：表示以传值方式访问所有变量；</p>
<p>[&amp;]：表示以引用方式访问所有变量；</p>
<div>
<pre class="prettyprint linenums"> 　　int count3 = ;<br />
     int count13 = ;<br />
     vector&lt;int&gt; numbers();<br />
     generate(numbers.begin(), numbers.end(), rand);<br />
     for_each(numbers.begin(), numbers.end(), <strong>[&amp;]</strong>(int x){ count3 += x %  == 　　　　　　　　;  count13 += x %  == ;});

 　　cout &lt;&lt; count3 &lt;&lt; "     " &lt;&lt; count13 &lt;&lt; endl;</pre>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/759985/201507/011353012816152.png" /></p>
<pre class="prettyprint linenums"></pre>
</div>
<p><strong>注意：</strong></p>
<p>C++引入lambda的主要目的是为了简化程序的编写，<strong>典型的</strong><strong>lambda</strong><strong>是测试表达式或者比较表达式</strong>，因为它们一般只有一条返回语句，因此可以使用返回类型自动推断。</p>
<h1>13 可变参数模板</h1>
<p>C++ 11提供了一个用省略号表示的元运算符,使得可以声明表示模板参数列表,其语法如下:</p>
<p>template&lt;typename... Args&gt;</p>
<p>void show(Args... args){ }</p>
<p>其中Args表示模板参数列表，args表示函数参数列表。</p>
<p>这里有一个问题，我们如何访问具体的某个参数呢？使用args[2]吗?答案是否定的，我们在可变参数中不能使用索引来访问，这里需要递归地访问每个参数：</p>
<p>template&lt;typename T, typename... Args&gt;</p>
<p>void <strong>show(</strong>T value, Args... args)</p>
<p>{</p>
<p>cout &lt;&lt; value &lt;&lt; &ldquo;, &rdquo;;</p>
<p><strong>show(args...);</strong></p>
<p>}</p>
<p>每次调用show，可变参数将减少一个，直到调用show()时，调用参数为空，不接受，则退出递归。</p>
<h1>14 断言</h1>
<p>C++提供了调试工具assert，这是一个宏，用于在<strong>运行阶段</strong>对断言进行检查，如果为true，则显示一条消息，否则调用abort();</p>
<p>C++ 11新增了关键字static_assert，可用于在<strong>编译阶段</strong>对断言进行测试。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9px674q.html">STEP模块&mdash;&mdash;电子琴</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j24dw8.html">ArcEngine &colon;The XY domain on the spatial reference is not set or invalid错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdkx4z9.html">重走java---Step 1</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxxpkeq.html">PHP----Ajax异步请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q71vn1q.html">web前端编写注意点</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gl2leq.html">更快、更强&mdash;&mdash;解析Hadoop新一代MapReduce框架Yarn（CSDN）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xrw3m8.html">Tomcat内存溢出解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjjlv79.html">UVALive 7297 Hounded by Indecision BFS</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd51g78.html">oracle desc 表结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z136w19.html">第二百八十五天 how can I 坚持</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1dnyj9.html">Excel导入导出帮助类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnvg4d8.html">Extjs 兼容IE10</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z0yr59.html">tomcat配置访问日志&comma;访问首页主目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljn55e9.html">laravel安装excel功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4znloe9.html">Git版本管理荟萃</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjgz2k8.html">Android WebView 缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r24g39.html">AI学习---TensorFlow框架介绍&lbrack;图&plus;会话&plus;张量&plus;变量OP&plus;API&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1566pq.html">一起学Hadoop&mdash;&mdash;Hadoop的前世今生</a>
		</li>
						<li><a href="https://www.batexi.com/a/960zg6y9.html">2019&period;02&period;17 spoj Query on a tree VII（链分治）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll0060q.html">【Linux】阿里云服务器部署--禅道</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96o30jn9.html">轻松找回Win7桌面&OpenCurlyDoubleQuote;消失&rdquo;的IE9图标</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wk5xxq.html">【MySQL】InnoDB引擎ibdata文件损坏&sol;删除后使用frm和ibd文件恢复数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvve2lyq.html">WP&lowbar;3种磁贴效果设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1oon59.html">&dollar;watch 和 &dollar;apply</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x33em8.html">leetcode 67</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1kr519.html">Install SQLite</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok45lp9.html">Sublime Text 使用 Emmet 补全错误问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm1vm09.html">SDUST 作业10 Problem I 液晶显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjpgx49.html">SublimeText快捷键大全&lpar;附GIF演示图&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1o2er9.html">css下拉菜单效果</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
